error handling
[oweals/gnunet.git] / src / gns / test_plugin_rest_gns.sh
1 #!/bin/sh
2 # This file is in the public domain.
3 trap "gnunet-arm -e -c test_gns_lookup.conf" INT
4 LOCATION=$(which gnunet-config)
5 if [ -z $LOCATION ]
6 then
7   LOCATION="gnunet-config"
8 fi
9 $LOCATION --version 1> /dev/null
10 if test $? != 0
11 then
12         echo "GNUnet command line tools cannot be found, check environmental variables PATH and GNUNET_PREFIX"
13         exit 77
14 fi
15
16 rm -rf `gnunet-config -c test_gns_lookup.conf -f -s paths -o GNUNET_TEST_HOME`
17
18 gns_link="http://localhost:7776/gns"
19 wrong_link="http://localhost:7776/gnsandmore"
20
21 curl_get () {
22     #$1 is link
23     #$2 is grep
24     XURL=`which gnurl || which curl`
25     if [ "" = "$XURL" ]
26     then
27         echo "HTTP client (curl/gnurl) not found, exiting"
28         exit 77
29     fi
30     sleep 0.5
31     cache="$(${XURL} -v "$1" 2>&1 | grep "$2")"
32     #echo "$cache"
33     if [ "" = "$cache" ]
34     then
35         gnunet-identity -D "$TEST_TLD" -c test_gns_lookup.conf > /dev/null 2>&1
36         gnunet-arm -e -c test_gns_lookup.conf
37         echo "Download of $1 using $XURL failed"
38         exit 1
39     fi
40 }
41 TEST_TLD="testtld"
42
43 gnunet-arm -s -c test_gns_lookup.conf
44 curl_get "$gns_link/www.$TEST_TLD" "error"
45
46 gnunet-identity -C "$TEST_TLD"  -c test_gns_lookup.conf
47 sleep 0.5
48 curl_get "$gns_link/www.$TEST_TLD" "\[\]"
49
50 gnunet-namestore -z "$TEST_TLD" -p -a -n www -e 1d -V 1.1.1.1 -t A -c test_gns_lookup.conf
51
52 curl_get "$gns_link/www.$TEST_TLD" "1.1.1.1"
53
54 gnunet-namestore -z "$TEST_TLD" -p -a -n www -e 1d -V 1::1 -t AAAA -c test_gns_lookup.conf
55
56 curl_get "$gns_link/www.$TEST_TLD" "1::1.*1.1.1.1"
57
58 gnunet-namestore -z "$TEST_TLD" -p -a -n www -e 1d -V 1.1.1.2 -t A -c test_gns_lookup.conf
59
60 curl_get "$gns_link/www.$TEST_TLD" "1.1.1.2.*1::1.*1.1.1.1"
61 curl_get "$gns_link/www.$TEST_TLD?record_type=A" "1.1.1.2.*1.1.1.1"
62 curl_get "$gns_link/www.$TEST_TLD?record_type=AAAA" "1::1"
63 curl_get "$gns_link/www.$TEST_TLD?record_type=WRONG_TYPE" "1.1.1.2.*1::1.*1.1.1.1"
64
65 gnunet-namestore -z "$TEST_TLD" -p -a -n www1 -e 1d -V 1.1.1.1 -t A -c test_gns_lookup.conf
66 curl_get "$gns_link/www1.$TEST_TLD" "1.1.1.1"
67
68 gnunet-namestore -z "$TEST_TLD" -d -n www1 -c test_gns_lookup.conf
69 gnunet-namestore -z "$TEST_TLD" -d -n www -c test_gns_lookup.conf
70
71 gnunet-identity -D "$TEST_TLD" -c test_gns_lookup.conf > /dev/null 2>&1
72
73 curl_get "$gns_link/www1.$TEST_TLD" "error"
74 gnunet-arm -e -c test_gns_lookup.conf
75 exit 0